Object.defineProperty(exports, "__esModule", { value: true });
exports.NativeScriptUIListViewModule = exports.LISTVIEW_DIRECTIVES = exports.getItemViewRoot = exports.TKListViewLayoutDirective = exports.TKListViewLoadOnDemandDirective = exports.TKTemplateKeyDirective = exports.TKGroupTemplateDirective = exports.TKListViewItemDirective = exports.TKListViewItemSwipeDirective = exports.TKListViewFooterDirective = exports.TKListViewHeaderDirective = exports.ReorderHandleDirective = exports.ListViewStaggeredLayoutDirective = exports.ListViewGridLayoutDirective = exports.ListViewLinearLayoutDirective = exports.RadListViewComponent = exports.ListItemContext = void 0;
var core_1 = require("@angular/core");
var angular_1 = require("@nativescript/angular");
var __1 = require("./../");
var core_2 = require("@nativescript/core");
var i0 = require("@angular/core");
var i1 = require("@nativescript/angular");
var _c0 = ["loader"];
var ListItemContext = /** @class */ (function (_super) {
    __extends(ListItemContext, _super);
    function ListItemContext($implicit, item, index, even, odd, category) {
        var _this = _super.call(this, item) || this;
        _this.$implicit = $implicit;
        _this.item = item;
        _this.index = index;
        _this.even = even;
        _this.odd = odd;
        _this.category = category;
        return _this;
    }
    return ListItemContext;
}(core_1.ElementRef));
exports.ListItemContext = ListItemContext;
var RadListViewComponent = /** @class */ (function () {
    function RadListViewComponent(_elementRef, _iterableDiffers, _renderer) {
        var _this = this;
        this._elementRef = _elementRef;
        this._iterableDiffers = _iterableDiffers;
        this._renderer = _renderer;
        this.setupItemView = new core_1.EventEmitter();
        this.changeAnimationsEnabled = true;
        this._listView = _elementRef.nativeElement;
        // We should consider setting this default value in the RadListView constructor.
        this._listView.listViewLayout = new __1.ListViewLinearLayout();
        var component = this;
        this._listView.itemViewDisposer = function () {
            _this.loader.clear();
        };
        this._listView.nativeScriptViewAdded = function (parent, child) {
            // Consider exposing this in nativescript-angular as public API
            _this._renderer.viewUtil.insertChild(parent, child);
        };
        this._listView.itemViewLoader = function (viewType) {
            switch (viewType) {
                case __1.ListViewViewType.ItemView:
                    if (component._itemTemplate && _this.loader) {
                        var nativeItem = _this.loader.createEmbeddedView(component._itemTemplate, new ListItemContext(), 0);
                        var typedView = getItemViewRoot(nativeItem);
                        typedView[__1.NG_VIEW] = nativeItem;
                        return typedView;
                    }
                    break;
                case __1.ListViewViewType.ItemSwipeView:
                    if (component._itemSwipeTemplate && _this.loader) {
                        var nativeItem = _this.loader.createEmbeddedView(component._itemSwipeTemplate, new ListItemContext(), 0);
                        var typedView = getItemViewRoot(nativeItem);
                        typedView[__1.NG_VIEW] = nativeItem;
                        return typedView;
                    }
                    break;
                case __1.ListViewViewType.LoadOnDemandView:
                    if (component._loadOnDemandTemplate && _this.loader) {
                        var viewRef = _this.loader.createEmbeddedView(component._loadOnDemandTemplate, new ListItemContext(), 0);
                        _this.detectChangesOnChild(viewRef, -1);
                        var nativeView = getItemViewRoot(viewRef);
                        nativeView[__1.NG_VIEW] = viewRef;
                        return nativeView;
                    }
                    break;
                case __1.ListViewViewType.HeaderView:
                    if (component._headerTemplate && _this.loader) {
                        var viewRef = _this.loader.createEmbeddedView(component._headerTemplate, new ListItemContext(), 0);
                        _this.detectChangesOnChild(viewRef, -1);
                        var nativeView = getItemViewRoot(viewRef);
                        nativeView[__1.NG_VIEW] = viewRef;
                        return nativeView;
                    }
                    break;
                case __1.ListViewViewType.GroupView:
                    if (!_this._listView.groupingFunction && _this._listView._hasGroupingFunctionChanged) {
                        break;
                    }
                    if (component._groupTemplate && _this.loader) {
                        var viewRef = _this.loader.createEmbeddedView(component._groupTemplate, new ListItemContext(), 0);
                        _this.detectChangesOnChild(viewRef, -1);
                        var nativeView = getItemViewRoot(viewRef);
                        nativeView[__1.NG_VIEW] = viewRef;
                        return nativeView;
                    }
                    break;
                case __1.ListViewViewType.FooterView:
                    if (component._footerTemplate && _this.loader) {
                        var viewRef = _this.loader.createEmbeddedView(component._footerTemplate, new ListItemContext(), 0);
                        _this.detectChangesOnChild(viewRef, -1);
                        var nativeView = getItemViewRoot(viewRef);
                        nativeView[__1.NG_VIEW] = viewRef;
                        return nativeView;
                    }
                    break;
            }
        };
    }
    RadListViewComponent.prototype.ngAfterContentInit = function () {
        this.setItemTemplates();
    };
    Object.defineProperty(RadListViewComponent.prototype, "nativeElement", {
        get: function () {
            return this._listView;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadListViewComponent.prototype, "listView", {
        get: function () {
            return this._listView;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadListViewComponent.prototype, "loadOnDemandTemplate", {
        set: function (value) {
            this._loadOnDemandTemplate = value;
            this._listView.refresh();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadListViewComponent.prototype, "headerTemplate", {
        set: function (value) {
            this._headerTemplate = value;
            if (this._listView.ios) {
                this._listView.updateHeaderFooter();
            }
            else if (this._listView.android) {
                this._listView['_updateHeader']();
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadListViewComponent.prototype, "groupTemplate", {
        set: function (value) {
            this._groupTemplate = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadListViewComponent.prototype, "footerTemplate", {
        set: function (value) {
            this._footerTemplate = value;
            if (this._listView.ios) {
                this._listView.updateHeaderFooter();
            }
            else if (this._listView.android) {
                this._listView['_updateFooter']();
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadListViewComponent.prototype, "itemTemplate", {
        set: function (value) {
            this._itemTemplate = value;
            this._listView.refresh();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadListViewComponent.prototype, "itemSwipeTemplate", {
        set: function (value) {
            this._itemSwipeTemplate = value;
            this._listView.refresh();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadListViewComponent.prototype, "items", {
        set: function (value) {
            this._items = value;
            var needDiffer = true;
            if (value instanceof core_2.ObservableArray) {
                needDiffer = false;
            }
            if (!this._differ) {
                if (needDiffer && core_1.ɵisListLikeIterable(value)) {
                    this._differ = this._iterableDiffers.find(this._items).create(this.trackBy || (function (index, item) { return item; }));
                }
                this._listView.items = this._items;
            }
        },
        enumerable: false,
        configurable: true
    });
    RadListViewComponent.prototype.ngDoCheck = function () {
        if (this._differ) {
            var changes_1 = this._differ.diff(this._items);
            if (changes_1) {
                var changeCounters_1 = {
                    added: 0,
                    moved: 0,
                    removed: 0,
                    changed: 0,
                };
                [
                    { fn: changes_1.forEachAddedItem, key: 'added' },
                    { fn: changes_1.forEachMovedItem, key: 'moved' },
                    { fn: changes_1.forEachRemovedItem, key: 'removed' },
                    { fn: changes_1.forEachIdentityChange, key: 'changed' },
                ].map(function (_a) {
                    var fn = _a.fn, key = _a.key;
                    var collector = [];
                    fn.bind(changes_1)(function (record) {
                        if (typeof record.previousIndex === 'number' && typeof record.currentIndex === 'number') {
                            collector.push(record.previousIndex + " -> " + record.currentIndex);
                        }
                        else {
                            collector.push("" + (record.previousIndex || record.currentIndex || 0));
                        }
                        changeCounters_1[key]++;
                    });
                    return key + "(" + collector + ")";
                });
                var previousItemCount = 0;
                for (var item in this._listView.items) {
                    previousItemCount++;
                }
                var incomingItemCount = 0;
                for (var item in this._items) {
                    incomingItemCount++;
                }
                var totalReplacement = (changeCounters_1.added === incomingItemCount && changeCounters_1.removed === previousItemCount)
                    || changeCounters_1.added > incomingItemCount
                    || changeCounters_1.removed > previousItemCount;
                if (!totalReplacement && core_2.isIOS) {
                    var collectionView_1 = this._listView.nativeViewProtected;
                    if (collectionView_1) {
                        var _listView_1 = this._listView;
                        var _items_1 = this._items;
                        var processUpdates_1 = (function () {
                            var nativePaths = NSMutableArray.alloc().init();
                            changes_1.forEachRemovedItem(function (record) {
                                nativePaths.addObject(NSIndexPath.indexPathForRowInSection(record.previousIndex, 0));
                            });
                            if (nativePaths.count) {
                                collectionView_1.deleteItemsAtIndexPaths(nativePaths);
                            }
                            nativePaths = NSMutableArray.alloc().init();
                            changes_1.forEachAddedItem(function (item) {
                                nativePaths.addObject(NSIndexPath.indexPathForRowInSection(item.currentIndex, 0));
                            });
                            if (nativePaths.count) {
                                collectionView_1.insertItemsAtIndexPaths(nativePaths);
                            }
                            nativePaths = NSMutableArray.alloc().init();
                            changes_1.forEachMovedItem(function (item) {
                                collectionView_1.moveItemAtIndexPathToIndexPath(NSIndexPath.indexPathForRowInSection(item.previousIndex, 0), NSIndexPath.indexPathForRowInSection(item.currentIndex, 0));
                            });
                            nativePaths = NSMutableArray.alloc().init();
                            changes_1.forEachIdentityChange(function (item) {
                                nativePaths.addObject(NSIndexPath.indexPathForRowInSection(item.currentIndex, 0));
                            });
                            if (nativePaths.count) {
                                collectionView_1.reloadItemsAtIndexPaths(nativePaths);
                            }
                            _listView_1.items = _items_1;
                        });
                        if (this.changeAnimationsEnabled) {
                            collectionView_1.performBatchUpdatesCompletion(processUpdates_1, function () { });
                        }
                        else {
                            UIView.performWithoutAnimation(function () {
                                collectionView_1.performBatchUpdatesCompletion(processUpdates_1, function () { });
                            });
                        }
                    }
                }
                else {
                    this._listView.items = this._items;
                    this._listView.refresh();
                }
            }
        }
    };
    RadListViewComponent.prototype.onItemLoadingInternal = function (args) {
        var index = args.index;
        var currentItem = args.view.bindingContext;
        var ngView = args.view[__1.NG_VIEW];
        // Getting angular view from original element (in cases when ProxyViewContainer
        // is used NativeScript internally wraps it in a StackLayout)
        if (!ngView && args.view instanceof core_2.LayoutBase && args.view.getChildrenCount() > 0) {
            ngView = args.view.getChildAt(0)[__1.NG_VIEW];
        }
        if (ngView) {
            this.setupViewRef(ngView, currentItem, index);
            this.detectChangesOnChild(ngView, index);
        }
    };
    RadListViewComponent.prototype.setupViewRef = function (viewRef, data, index) {
        var context = viewRef.context;
        context.$implicit = data;
        context.item = data;
        context.category = data ? data.category : "";
        context.index = index;
        context.even = (index % 2 === 0);
        context.odd = !context.even;
        this.setupItemView.next({ view: viewRef, data: data, index: index, context: context });
        // this.detectChangesOnChild(viewRef, -1);
    };
    RadListViewComponent.prototype.setLayout = function (layout) {
        this._listView.listViewLayout = layout;
    };
    RadListViewComponent.prototype.detectChangesOnChild = function (viewRef, index) {
        // Manually detect changes in child view ref
        // TODO: Is there a better way of getting viewRef's change detector
        var childChangeDetector = viewRef;
        childChangeDetector.markForCheck();
        childChangeDetector.detectChanges();
    };
    RadListViewComponent.prototype.setItemTemplates = function () {
        // The itemTemplateQuery may be changed after list items are added that contain <template> inside,
        // so cache and use only the original template to avoid errors.
        this.itemTemplate = this.itemTemplateQuery;
        if (this._templateMap) {
            var templates_1 = [];
            this._templateMap.forEach(function (value) {
                templates_1.push(value);
            });
            this.listView.itemTemplates = templates_1;
        }
    };
    RadListViewComponent.prototype.registerTemplate = function (key, template) {
        var _this = this;
        if (!this._templateMap) {
            this._templateMap = new Map();
        }
        var keyedTemplate = {
            key: key,
            createView: function () {
                var viewRef = _this.loader.createEmbeddedView(template, new ListItemContext(), 0);
                var resultView = getItemViewRoot(viewRef);
                resultView[__1.NG_VIEW] = viewRef;
                return resultView;
            }
        };
        this._templateMap.set(key, keyedTemplate);
    };
    RadListViewComponent.ɵfac = function RadListViewComponent_Factory(t) { return new (t || RadListViewComponent)(i0.ɵɵdirectiveInject(core_1.ElementRef), i0.ɵɵdirectiveInject(core_1.IterableDiffers), i0.ɵɵdirectiveInject(angular_1.NativeScriptRendererFactory)); };
    RadListViewComponent.ɵcmp = i0.ɵɵdefineComponent({ type: RadListViewComponent, selectors: [["RadListView"]], contentQueries: function RadListViewComponent_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵstaticContentQuery(dirIndex, core_1.TemplateRef, true, core_1.TemplateRef);
        } if (rf & 2) {
            var _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.itemTemplateQuery = _t.first);
        } }, viewQuery: function RadListViewComponent_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵstaticViewQuery(_c0, true, core_1.ViewContainerRef);
        } if (rf & 2) {
            var _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.loader = _t.first);
        } }, hostBindings: function RadListViewComponent_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("itemLoadingInternal", function RadListViewComponent_itemLoadingInternal_HostBindingHandler($event) { return ctx.onItemLoadingInternal($event); });
        } }, inputs: { changeAnimationsEnabled: "changeAnimationsEnabled", trackBy: "trackBy", items: "items" }, outputs: { setupItemView: "setupItemView" }, decls: 3, vars: 0, consts: [["loader", ""]], template: function RadListViewComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "DetachedContainer");
            i0.ɵɵelement(1, "Placeholder", null, 0);
            i0.ɵɵelementEnd();
        } }, encapsulation: 2, changeDetection: 0 });
    return RadListViewComponent;
}());
exports.RadListViewComponent = RadListViewComponent;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(RadListViewComponent, [{
        type: core_1.Component,
        args: [{
                selector: "RadListView",
                template: "\n        <DetachedContainer>\n            <Placeholder #loader></Placeholder>\n        </DetachedContainer>",
                changeDetection: core_1.ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: i0.ElementRef, decorators: [{
                type: core_1.Inject,
                args: [core_1.ElementRef]
            }] }, { type: i0.IterableDiffers, decorators: [{
                type: core_1.Inject,
                args: [core_1.IterableDiffers]
            }] }, { type: i1.NativeScriptRendererFactory, decorators: [{
                type: core_1.Inject,
                args: [angular_1.NativeScriptRendererFactory]
            }] }]; }, { loader: [{
            type: core_1.ViewChild,
            args: ["loader", { read: core_1.ViewContainerRef, static: true }]
        }], setupItemView: [{
            type: core_1.Output
        }], itemTemplateQuery: [{
            type: core_1.ContentChild,
            args: [core_1.TemplateRef, { read: core_1.TemplateRef, static: true }]
        }], changeAnimationsEnabled: [{
            type: core_1.Input
        }], trackBy: [{
            type: core_1.Input
        }], items: [{
            type: core_1.Input
        }], onItemLoadingInternal: [{
            type: core_1.HostListener,
            args: ["itemLoadingInternal", ['$event']]
        }] }); })();
var ListViewLinearLayoutDirective = /** @class */ (function () {
    function ListViewLinearLayoutDirective() {
    }
    ListViewLinearLayoutDirective.ɵfac = function ListViewLinearLayoutDirective_Factory(t) { return new (t || ListViewLinearLayoutDirective)(); };
    ListViewLinearLayoutDirective.ɵdir = i0.ɵɵdefineDirective({ type: ListViewLinearLayoutDirective, selectors: [["ListViewLinearLayout"]] });
    return ListViewLinearLayoutDirective;
}());
exports.ListViewLinearLayoutDirective = ListViewLinearLayoutDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ListViewLinearLayoutDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "ListViewLinearLayout"
            }]
    }], function () { return []; }, null); })();
var ListViewGridLayoutDirective = /** @class */ (function () {
    function ListViewGridLayoutDirective() {
    }
    ListViewGridLayoutDirective.ɵfac = function ListViewGridLayoutDirective_Factory(t) { return new (t || ListViewGridLayoutDirective)(); };
    ListViewGridLayoutDirective.ɵdir = i0.ɵɵdefineDirective({ type: ListViewGridLayoutDirective, selectors: [["ListViewGridLayout"]] });
    return ListViewGridLayoutDirective;
}());
exports.ListViewGridLayoutDirective = ListViewGridLayoutDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ListViewGridLayoutDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "ListViewGridLayout"
            }]
    }], function () { return []; }, null); })();
var ListViewStaggeredLayoutDirective = /** @class */ (function () {
    function ListViewStaggeredLayoutDirective() {
    }
    ListViewStaggeredLayoutDirective.ɵfac = function ListViewStaggeredLayoutDirective_Factory(t) { return new (t || ListViewStaggeredLayoutDirective)(); };
    ListViewStaggeredLayoutDirective.ɵdir = i0.ɵɵdefineDirective({ type: ListViewStaggeredLayoutDirective, selectors: [["ListViewStaggeredLayout"]] });
    return ListViewStaggeredLayoutDirective;
}());
exports.ListViewStaggeredLayoutDirective = ListViewStaggeredLayoutDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ListViewStaggeredLayoutDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "ListViewStaggeredLayout"
            }]
    }], function () { return []; }, null); })();
var ReorderHandleDirective = /** @class */ (function () {
    function ReorderHandleDirective() {
    }
    ReorderHandleDirective.ɵfac = function ReorderHandleDirective_Factory(t) { return new (t || ReorderHandleDirective)(); };
    ReorderHandleDirective.ɵdir = i0.ɵɵdefineDirective({ type: ReorderHandleDirective, selectors: [["ReorderHandle"]] });
    return ReorderHandleDirective;
}());
exports.ReorderHandleDirective = ReorderHandleDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ReorderHandleDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "ReorderHandle"
            }]
    }], function () { return []; }, null); })();
var TKListViewHeaderDirective = /** @class */ (function () {
    function TKListViewHeaderDirective(owner, template) {
        this.owner = owner;
        this.template = template;
    }
    TKListViewHeaderDirective.prototype.ngOnInit = function () {
        this.owner.headerTemplate = this.template;
    };
    TKListViewHeaderDirective.ɵfac = function TKListViewHeaderDirective_Factory(t) { return new (t || TKListViewHeaderDirective)(i0.ɵɵdirectiveInject(RadListViewComponent), i0.ɵɵdirectiveInject(core_1.TemplateRef)); };
    TKListViewHeaderDirective.ɵdir = i0.ɵɵdefineDirective({ type: TKListViewHeaderDirective, selectors: [["", "tkListViewHeader", ""]] });
    return TKListViewHeaderDirective;
}());
exports.TKListViewHeaderDirective = TKListViewHeaderDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TKListViewHeaderDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "[tkListViewHeader]"
            }]
    }], function () { return [{ type: RadListViewComponent, decorators: [{
                type: core_1.Inject,
                args: [RadListViewComponent]
            }] }, { type: i0.TemplateRef, decorators: [{
                type: core_1.Inject,
                args: [core_1.TemplateRef]
            }] }]; }, null); })();
var TKListViewFooterDirective = /** @class */ (function () {
    function TKListViewFooterDirective(owner, template) {
        this.owner = owner;
        this.template = template;
    }
    TKListViewFooterDirective.prototype.ngOnInit = function () {
        this.owner.footerTemplate = this.template;
    };
    TKListViewFooterDirective.ɵfac = function TKListViewFooterDirective_Factory(t) { return new (t || TKListViewFooterDirective)(i0.ɵɵdirectiveInject(RadListViewComponent), i0.ɵɵdirectiveInject(core_1.TemplateRef)); };
    TKListViewFooterDirective.ɵdir = i0.ɵɵdefineDirective({ type: TKListViewFooterDirective, selectors: [["", "tkListViewFooter", ""]] });
    return TKListViewFooterDirective;
}());
exports.TKListViewFooterDirective = TKListViewFooterDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TKListViewFooterDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "[tkListViewFooter]"
            }]
    }], function () { return [{ type: RadListViewComponent, decorators: [{
                type: core_1.Inject,
                args: [RadListViewComponent]
            }] }, { type: i0.TemplateRef, decorators: [{
                type: core_1.Inject,
                args: [core_1.TemplateRef]
            }] }]; }, null); })();
var TKListViewItemSwipeDirective = /** @class */ (function () {
    function TKListViewItemSwipeDirective(owner, template) {
        this.owner = owner;
        this.template = template;
    }
    TKListViewItemSwipeDirective.prototype.ngOnInit = function () {
        this.owner.itemSwipeTemplate = this.template;
    };
    TKListViewItemSwipeDirective.ɵfac = function TKListViewItemSwipeDirective_Factory(t) { return new (t || TKListViewItemSwipeDirective)(i0.ɵɵdirectiveInject(RadListViewComponent), i0.ɵɵdirectiveInject(core_1.TemplateRef)); };
    TKListViewItemSwipeDirective.ɵdir = i0.ɵɵdefineDirective({ type: TKListViewItemSwipeDirective, selectors: [["", "tkListItemSwipeTemplate", ""]] });
    return TKListViewItemSwipeDirective;
}());
exports.TKListViewItemSwipeDirective = TKListViewItemSwipeDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TKListViewItemSwipeDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "[tkListItemSwipeTemplate]"
            }]
    }], function () { return [{ type: RadListViewComponent, decorators: [{
                type: core_1.Inject,
                args: [RadListViewComponent]
            }] }, { type: i0.TemplateRef, decorators: [{
                type: core_1.Inject,
                args: [core_1.TemplateRef]
            }] }]; }, null); })();
var TKListViewItemDirective = /** @class */ (function () {
    function TKListViewItemDirective(owner, template) {
        this.owner = owner;
        this.template = template;
    }
    TKListViewItemDirective.prototype.ngOnInit = function () {
        this.owner.itemTemplate = this.template;
    };
    TKListViewItemDirective.ɵfac = function TKListViewItemDirective_Factory(t) { return new (t || TKListViewItemDirective)(i0.ɵɵdirectiveInject(RadListViewComponent), i0.ɵɵdirectiveInject(core_1.TemplateRef)); };
    TKListViewItemDirective.ɵdir = i0.ɵɵdefineDirective({ type: TKListViewItemDirective, selectors: [["", "tkListItemTemplate", ""]] });
    return TKListViewItemDirective;
}());
exports.TKListViewItemDirective = TKListViewItemDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TKListViewItemDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "[tkListItemTemplate]"
            }]
    }], function () { return [{ type: RadListViewComponent, decorators: [{
                type: core_1.Inject,
                args: [RadListViewComponent]
            }] }, { type: i0.TemplateRef, decorators: [{
                type: core_1.Inject,
                args: [core_1.TemplateRef]
            }] }]; }, null); })();
var TKGroupTemplateDirective = /** @class */ (function () {
    function TKGroupTemplateDirective(owner, template) {
        this.owner = owner;
        this.template = template;
    }
    TKGroupTemplateDirective.prototype.ngOnInit = function () {
        this.owner.groupTemplate = this.template;
    };
    TKGroupTemplateDirective.ɵfac = function TKGroupTemplateDirective_Factory(t) { return new (t || TKGroupTemplateDirective)(i0.ɵɵdirectiveInject(RadListViewComponent), i0.ɵɵdirectiveInject(core_1.TemplateRef)); };
    TKGroupTemplateDirective.ɵdir = i0.ɵɵdefineDirective({ type: TKGroupTemplateDirective, selectors: [["", "tkGroupTemplate", ""]] });
    return TKGroupTemplateDirective;
}());
exports.TKGroupTemplateDirective = TKGroupTemplateDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TKGroupTemplateDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "[tkGroupTemplate]"
            }]
    }], function () { return [{ type: RadListViewComponent, decorators: [{
                type: core_1.Inject,
                args: [RadListViewComponent]
            }] }, { type: i0.TemplateRef, decorators: [{
                type: core_1.Inject,
                args: [core_1.TemplateRef]
            }] }]; }, null); })();
var TKTemplateKeyDirective = /** @class */ (function () {
    function TKTemplateKeyDirective(templateRef, owner) {
        this.templateRef = templateRef;
        this.owner = owner;
    }
    Object.defineProperty(TKTemplateKeyDirective.prototype, "tkTemplateKey", {
        set: function (value) {
            if (this.owner && this.templateRef) {
                this.owner.registerTemplate(value, this.templateRef);
            }
        },
        enumerable: false,
        configurable: true
    });
    TKTemplateKeyDirective.ɵfac = function TKTemplateKeyDirective_Factory(t) { return new (t || TKTemplateKeyDirective)(i0.ɵɵdirectiveInject(i0.TemplateRef), i0.ɵɵdirectiveInject(RadListViewComponent, 1)); };
    TKTemplateKeyDirective.ɵdir = i0.ɵɵdefineDirective({ type: TKTemplateKeyDirective, selectors: [["", "tkTemplateKey", ""]], inputs: { tkTemplateKey: "tkTemplateKey" } });
    return TKTemplateKeyDirective;
}());
exports.TKTemplateKeyDirective = TKTemplateKeyDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TKTemplateKeyDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "[tkTemplateKey]"
            }]
    }], function () { return [{ type: i0.TemplateRef }, { type: RadListViewComponent, decorators: [{
                type: core_1.Host
            }] }]; }, { tkTemplateKey: [{
            type: core_1.Input
        }] }); })();
var TKListViewLoadOnDemandDirective = /** @class */ (function () {
    function TKListViewLoadOnDemandDirective(owner, template) {
        this.owner = owner;
        this.template = template;
    }
    TKListViewLoadOnDemandDirective.prototype.ngOnInit = function () {
        this.owner.loadOnDemandTemplate = this.template;
    };
    TKListViewLoadOnDemandDirective.ɵfac = function TKListViewLoadOnDemandDirective_Factory(t) { return new (t || TKListViewLoadOnDemandDirective)(i0.ɵɵdirectiveInject(RadListViewComponent), i0.ɵɵdirectiveInject(core_1.TemplateRef)); };
    TKListViewLoadOnDemandDirective.ɵdir = i0.ɵɵdefineDirective({ type: TKListViewLoadOnDemandDirective, selectors: [["", "tkListLoadOnDemandTemplate", ""]] });
    return TKListViewLoadOnDemandDirective;
}());
exports.TKListViewLoadOnDemandDirective = TKListViewLoadOnDemandDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TKListViewLoadOnDemandDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "[tkListLoadOnDemandTemplate]"
            }]
    }], function () { return [{ type: RadListViewComponent, decorators: [{
                type: core_1.Inject,
                args: [RadListViewComponent]
            }] }, { type: i0.TemplateRef, decorators: [{
                type: core_1.Inject,
                args: [core_1.TemplateRef]
            }] }]; }, null); })();
var TKListViewLayoutDirective = /** @class */ (function () {
    function TKListViewLayoutDirective(owner, _elementRef) {
        this.owner = owner;
        this._elementRef = _elementRef;
    }
    TKListViewLayoutDirective.prototype.ngOnInit = function () {
        var layout = this._elementRef.nativeElement;
        this.owner.setLayout(layout);
    };
    TKListViewLayoutDirective.ɵfac = function TKListViewLayoutDirective_Factory(t) { return new (t || TKListViewLayoutDirective)(i0.ɵɵdirectiveInject(RadListViewComponent), i0.ɵɵdirectiveInject(core_1.ElementRef)); };
    TKListViewLayoutDirective.ɵdir = i0.ɵɵdefineDirective({ type: TKListViewLayoutDirective, selectors: [["", "tkListViewLayout", ""]] });
    return TKListViewLayoutDirective;
}());
exports.TKListViewLayoutDirective = TKListViewLayoutDirective;
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TKListViewLayoutDirective, [{
        type: core_1.Directive,
        args: [{
                selector: "[tkListViewLayout]"
            }]
    }], function () { return [{ type: RadListViewComponent, decorators: [{
                type: core_1.Inject,
                args: [RadListViewComponent]
            }] }, { type: i0.ElementRef, decorators: [{
                type: core_1.Inject,
                args: [core_1.ElementRef]
            }] }]; }, null); })();
function getItemViewRoot(viewRef, rootLocator) {
    if (rootLocator === void 0) { rootLocator = angular_1.getSingleViewRecursive; }
    return rootLocator(viewRef.rootNodes, 0);
}
exports.getItemViewRoot = getItemViewRoot;
exports.LISTVIEW_DIRECTIVES = [RadListViewComponent, TKListViewItemDirective, TKListViewItemSwipeDirective, TKListViewHeaderDirective, TKListViewFooterDirective, TKListViewLoadOnDemandDirective, TKListViewLayoutDirective, ListViewGridLayoutDirective, ListViewStaggeredLayoutDirective, ReorderHandleDirective, ListViewLinearLayoutDirective, TKTemplateKeyDirective, TKGroupTemplateDirective];
angular_1.registerElement("RadListView", function () { return __1.RadListView; });
angular_1.registerElement("ListViewLinearLayout", function () { return __1.ListViewLinearLayout; });
angular_1.registerElement("ListViewGridLayout", function () { return __1.ListViewGridLayout; });
angular_1.registerElement("ListViewStaggeredLayout", function () { return __1.ListViewStaggeredLayout; });
angular_1.registerElement("ReorderHandle", function () { return __1.ReorderHandle; });
var NativeScriptUIListViewModule = /** @class */ (function () {
    function NativeScriptUIListViewModule() {
    }
    NativeScriptUIListViewModule.ɵmod = i0.ɵɵdefineNgModule({ type: NativeScriptUIListViewModule });
    NativeScriptUIListViewModule.ɵinj = i0.ɵɵdefineInjector({ factory: function NativeScriptUIListViewModule_Factory(t) { return new (t || NativeScriptUIListViewModule)(); } });
    return NativeScriptUIListViewModule;
}());
exports.NativeScriptUIListViewModule = NativeScriptUIListViewModule;
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(NativeScriptUIListViewModule, { declarations: [RadListViewComponent, TKListViewItemDirective, TKListViewItemSwipeDirective, TKListViewHeaderDirective, TKListViewFooterDirective, TKListViewLoadOnDemandDirective, TKListViewLayoutDirective, ListViewGridLayoutDirective, ListViewStaggeredLayoutDirective, ReorderHandleDirective, ListViewLinearLayoutDirective, TKTemplateKeyDirective, TKGroupTemplateDirective], exports: [RadListViewComponent, TKListViewItemDirective, TKListViewItemSwipeDirective, TKListViewHeaderDirective, TKListViewFooterDirective, TKListViewLoadOnDemandDirective, TKListViewLayoutDirective, ListViewGridLayoutDirective, ListViewStaggeredLayoutDirective, ReorderHandleDirective, ListViewLinearLayoutDirective, TKTemplateKeyDirective, TKGroupTemplateDirective] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(NativeScriptUIListViewModule, [{
        type: core_1.NgModule,
        args: [{
                declarations: [exports.LISTVIEW_DIRECTIVES],
                exports: [exports.LISTVIEW_DIRECTIVES],
                schemas: [
                    core_1.NO_ERRORS_SCHEMA
                ]
            }]
    }], null, null); })();
